#include <unistd.h>

#include <stdio.h>

#include <hipc/posix/clientutils.h>
#include <hipc/session.h>

#include "CFGled.h"
#include "CFGled_ccfg.h"

int main(void)
{
    hipc_session sess;
    struct STRUprm prm;
    int fdr = STDIN_FILENO;
    int fdw = STDOUT_FILENO;
    int i;
    unsigned int len;

    hipcOpen(&sess, &HIPCUD_CFGled_CCFG,
             hipcPosixReadMsg, &fdr, hipcPosixWriteMsg, &fdw);
    HIPC_ERRCHECK(&sess);

    len = 1600;
    for (i = 0; i < 4; ++i) {
        prm.led = 1;
        hipcPut(&sess, "STRUprm.led", &prm);
        HIPC_ERRCHECK(&sess);
        usleep(len * 1000);
        len /= 2;

        prm.led = 0;
        hipcPut(&sess, "STRUprm.led", &prm);
        HIPC_ERRCHECK(&sess);
        usleep(1000 * 1000);
    }

    hipcClose(&sess);
    HIPC_ERRCHECK(&sess);
    fprintf(stderr, "end\n");

    return 0;
}
