#include <hipc.h>

#include "CFGrt.h"
#include "hipcsvs_rt.h"

#define LOOP_PERIOD 1000
#define LED_PIN 13

taskLoop(rt_task)
{
    struct HIPC_pbank *const pbank_p = &hipcsvsRt_pbank;
    struct STRUprm const *prm_p;
    portTickType xLastWakeTime;

    xLastWakeTime = xTaskGetTickCount();

    for (;;) {
        hipcPbankSwitchAccept(pbank_p);
        prm_p = static_cast < const struct STRUprm *>
            (hipcPbankGetReadOnlyPage(pbank_p));
        digitalWrite(LED_PIN, prm_p->led);
        vTaskDelayUntil(&xLastWakeTime, LOOP_PERIOD);
    }
}

void setup()
{
    pinMode(LED_PIN, OUTPUT);

    initMainLoopPriority(LOW_PRIORITY);
    initMainLoopStackSize(192);

    hipcsvsRtInit();
    createTaskLoop(rt_task, HIGH_PRIORITY);
}


void loop()
{
    Serial.begin(9600);
    hipcMain(NULL);
    Serial.flush();
    Serial.end();
    delay(1000);
}
