#ifndef HIPC_PBANK_H
#define HIPC_PBANK_H

#include <hipc.h>

enum HIPC_pbank_stat {
    HIPC_PBANK_STAT_GROUND,
    HIPC_PBANK_STAT_REQUESTED,
    HIPC_PBANK_STAT_ACCEPTED
};

struct HIPC_pbank {
    volatile enum HIPC_pbank_stat stat;
    size_t page_size;
    void *page_ro_p;
    void *page_rw_p;
};

#ifdef __cplusplus
extern "C" {
#endif

    extern void hipcPbankInit(struct HIPC_pbank *const bank_p,
                              void *const buf_p, const size_t page_size);
    extern size_t hipcPbankGetPageSize(struct HIPC_pbank *const bank_p);
    extern const void *hipcPbankGetReadOnlyPage(struct HIPC_pbank *const
                                                bank_p);
    extern void *hipcPbankGetWritablePage(struct HIPC_pbank *const bank_p);
    extern enum HIPC_pbank_stat
     hipcPbankGetStat(struct HIPC_pbank *const bank_p);
    extern enum HIPC_errno
     hipcPbankSwitchRequest(struct HIPC_pbank *const bank_p);
    extern int hipcPbankSwitchAccept(struct HIPC_pbank *const bank_p);
    extern enum HIPC_errno
     hipcPbankSwitchComplete(struct HIPC_pbank *const bank_p);
    extern enum HIPC_errno
     hipcPbankSwitchReqWaitCmpl(struct HIPC_pbank *const bank_p);

#ifdef __cplusplus
}
#endif
#endif
