#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

#include <hipc.h>

static void test_hipcMsghdrBdysize(void)
{
    unsigned char header[HIPC_MSGHDR_SIZE];

    header[HIPC_MSGHDR_BYTE_BDYSZ] = 44;

    header[HIPC_MSGHDR_BYTE_TYPE] = HIPC_MESSAGE_TYPE_PUT;
    assert(44 == hipcMsghdrBdysize(header));

    header[HIPC_MSGHDR_BYTE_TYPE] = HIPC_MESSAGE_TYPE_GET;
    assert(0 == hipcMsghdrBdysize(header));

    return;
}

static void test_hipcEndian(void)
{
    unsigned char endian;

    endian = hipcEndian();
    assert(0x6c /* 'l' */  == endian ||
           0x42 /* 'B' */  == endian ||
           0x6f /* 'o' */  == endian);

    return;
}

int main(int argc, char *argv[])
{
    if (2 != argc) {
        fprintf(stderr, "Usage: %s test_id\n", argv[0]);
        exit(EXIT_FAILURE);
    }

    switch (argv[1][0]) {
    case 'a':
        test_hipcMsghdrBdysize();
        break;
    case 'b':
        test_hipcEndian();
        break;
    default:
        fprintf(stderr, "Invalid test_id: %s \n", argv[1]);
        exit(EXIT_FAILURE);
    }

    return 0;
}
