#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

#include <hipc/queue.h>

static void test_hipcQueue(void)
{
    struct HIPC_queue queue;
    int buf[3];
    int *item_p;

    hipcQueueInit(&queue, buf, sizeof(buf[0]),
                  sizeof(buf) / sizeof(buf[0]));
    assert(sizeof(buf[0]) == hipcQueueItemSize(&queue));

    assert(NULL == hipcQueueEmpty(&queue));

    item_p = hipcQueueFull(&queue);
    assert(NULL != item_p);
    *item_p = 2;
    hipcQueuePush(&queue);      /* PUSH */

    assert(NULL != hipcQueueFull(&queue));

    item_p = hipcQueueEmpty(&queue);
    assert(NULL != item_p);
    assert(2 == *item_p);
    hipcQueuePop(&queue);       /* POP */

    assert(NULL == hipcQueueEmpty(&queue));

    item_p = hipcQueueFull(&queue);
    assert(NULL != item_p);
    *item_p = 3;
    hipcQueuePush(&queue);      /* PUSH */

    item_p = hipcQueueEmpty(&queue);
    assert(NULL != item_p);
    assert(3 == *item_p);

    item_p = hipcQueueFull(&queue);
    assert(NULL != item_p);
    *item_p = 5;
    hipcQueuePush(&queue);      /* PUSH */

    assert(NULL == hipcQueueFull(&queue));

    item_p = hipcQueueEmpty(&queue);
    assert(NULL != item_p);
    assert(3 == *item_p);
    hipcQueuePop(&queue);       /* POP */

    item_p = hipcQueueEmpty(&queue);
    assert(NULL != item_p);
    assert(5 == *item_p);

    item_p = hipcQueueFull(&queue);
    assert(NULL != item_p);
    *item_p = 7;
    hipcQueuePush(&queue);      /* PUSH */

    assert(NULL == hipcQueueFull(&queue));

    item_p = hipcQueueEmpty(&queue);
    assert(NULL != item_p);
    assert(5 == *item_p);
    hipcQueuePop(&queue);       /* POP */

    assert(NULL != hipcQueueFull(&queue));

    item_p = hipcQueueEmpty(&queue);
    assert(NULL != item_p);
    assert(7 == *item_p);
    hipcQueuePop(&queue);       /* POP */

    assert(NULL != hipcQueueFull(&queue));
    assert(NULL == hipcQueueEmpty(&queue));

    item_p = hipcQueueFull(&queue);
    assert(NULL != item_p);
    *item_p = 11;
    hipcQueuePush(&queue);      /* PUSH */
    item_p = hipcQueueFull(&queue);
    assert(NULL != item_p);
    *item_p = 13;
    hipcQueuePush(&queue);      /* PUSH */

    assert(NULL == hipcQueueFull(&queue));
    assert(NULL != hipcQueueEmpty(&queue));

    hipcQueueClear(&queue);

    assert(NULL != hipcQueueFull(&queue));
    assert(NULL == hipcQueueEmpty(&queue));

    item_p = hipcQueueFull(&queue);
    assert(NULL != item_p);
    *item_p = 17;
    hipcQueuePush(&queue);      /* PUSH */
    item_p = hipcQueueFull(&queue);
    assert(NULL != item_p);
    *item_p = 19;
    hipcQueuePush(&queue);      /* PUSH */

    assert(NULL == hipcQueueFull(&queue));

    item_p = hipcQueueEmpty(&queue);
    assert(NULL != item_p);
    assert(17 == *item_p);
    hipcQueuePop(&queue);       /* POP */

    assert(NULL != hipcQueueFull(&queue));
    assert(NULL != hipcQueueEmpty(&queue));

    hipcQueueClear(&queue);

    assert(NULL != hipcQueueFull(&queue));
    assert(NULL == hipcQueueEmpty(&queue));

    hipcQueueClear(&queue);

    assert(NULL != hipcQueueFull(&queue));
    assert(NULL == hipcQueueEmpty(&queue));

    return;
}

int main(int argc, char *argv[])
{
    if (2 != argc) {
        fprintf(stderr, "Usage: %s test_id\n", argv[0]);
        exit(EXIT_FAILURE);
    }

    switch (argv[1][0]) {
    case 'a':
        test_hipcQueue();
        break;
    default:
        fprintf(stderr, "Invalid test_id: %s \n", argv[1]);
        exit(EXIT_FAILURE);
    }

    return 0;
}
